"use strict";
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var _a, _RedisClientMultiCommand_createCommand, _RedisClientMultiCommand_createModuleCommand, _RedisClientMultiCommand_createFunctionCommand, _RedisClientMultiCommand_createScriptCommand, _RedisClientMultiCommand_executor, _RedisClientMultiCommand_selectedDB;
Object.defineProperty(exports, "__esModule", { value: true });
const commands_1 = require("../commands");
const multi_command_1 = require("../multi-command");
const commander_1 = require("../commander");
class RedisClientMultiCommand extends multi_command_1.default {
    static extend(config) {
        return (0, commander_1.attachConfig)({
            BaseClass: RedisClientMultiCommand,
            commands: commands_1.default,
            createCommand: __classPrivateFieldGet(RedisClientMultiCommand, _a, "m", _RedisClientMultiCommand_createCommand),
            createModuleCommand: __classPrivateFieldGet(RedisClientMultiCommand, _a, "m", _RedisClientMultiCommand_createModuleCommand),
            createFunctionCommand: __classPrivateFieldGet(RedisClientMultiCommand, _a, "m", _RedisClientMultiCommand_createFunctionCommand),
            createScriptCommand: __classPrivateFieldGet(RedisClientMultiCommand, _a, "m", _RedisClientMultiCommand_createScriptCommand),
            config
        });
    }
    constructor(executor, legacyMode = false) {
        super();
        // readonly #multi = new RedisMultiCommand();
        _RedisClientMultiCommand_executor.set(this, void 0);
        // readonly v4: Record<string, any> = {};
        _RedisClientMultiCommand_selectedDB.set(this, void 0);
        Object.defineProperty(this, "select", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: this.SELECT
        });
        Object.defineProperty(this, "EXEC", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: this.exec
        });
        __classPrivateFieldSet(this, _RedisClientMultiCommand_executor, executor, "f");
        // if (legacyMode) {
        //   this.#legacyMode();
        // }
    }
    // #legacyMode(): void {
    //   this.v4.addCommand = this.addCommand.bind(this);
    //   (this as any).addCommand = (...args: Array<any>): this => {
    //     this.#multi.addCommand(transformLegacyCommandArguments(args));
    //     return this;
    //   };
    //   this.v4.exec = this.exec.bind(this);
    //   (this as any).exec = (callback?: (err: Error | null, replies?: Array<unknown>) => unknown): void => {
    //     this.v4.exec()
    //       .then((reply: Array<unknown>) => {
    //         if (!callback) return;
    //         callback(null, reply);
    //       })
    //       .catch((err: Error) => {
    //         if (!callback) {
    //           // this.emit('error', err);
    //           return;
    //         }
    //         callback(err);
    //       });
    //   };
    //   for (const [name, command] of Object.entries(COMMANDS as RedisCommands)) {
    //     this.#defineLegacyCommand(name, command);
    //     (this as any)[name.toLowerCase()] ??= (this as any)[name];
    //   }
    // }
    // #defineLegacyCommand(this: any, name: string, command?: RedisCommand): void {
    //   this.v4[name] = this[name].bind(this.v4);
    //   this[name] = command && command.TRANSFORM_LEGACY_REPLY && command.transformReply ?
    //     (...args: Array<unknown>) => {
    //       this.#multi.addCommand(
    //         [name, ...transformLegacyCommandArguments(args)],
    //         command.transformReply
    //       );
    //       return this;
    //     } :
    //     (...args: Array<unknown>) => this.addCommand(name, ...args);
    // }
    SELECT(db, transformReply) {
        __classPrivateFieldSet(this, _RedisClientMultiCommand_selectedDB, db, "f");
        return this.addCommand(['SELECT', db.toString()], transformReply);
    }
    async exec(execAsPipeline = false) {
        if (execAsPipeline)
            return this.execAsPipeline();
        return this.handleExecReplies(await __classPrivateFieldGet(this, _RedisClientMultiCommand_executor, "f").call(this, this.queue, __classPrivateFieldGet(this, _RedisClientMultiCommand_selectedDB, "f"), multi_command_1.default.generateChainId()));
    }
    execTyped(execAsPipeline = false) {
        return this.exec(execAsPipeline);
    }
    async execAsPipeline() {
        if (this.queue.length === 0)
            return [];
        return this.transformReplies(await __classPrivateFieldGet(this, _RedisClientMultiCommand_executor, "f").call(this, this.queue, __classPrivateFieldGet(this, _RedisClientMultiCommand_selectedDB, "f")));
    }
    execAsPipelineTyped() {
        return this.execAsPipeline();
    }
}
exports.default = RedisClientMultiCommand;
_a = RedisClientMultiCommand, _RedisClientMultiCommand_executor = new WeakMap(), _RedisClientMultiCommand_selectedDB = new WeakMap(), _RedisClientMultiCommand_createCommand = function _RedisClientMultiCommand_createCommand(command, resp) {
    const transformReply = (0, commander_1.getTransformReply)(command, resp);
    return function () {
        return this.addCommand(command.transformArguments.apply(undefined, arguments), transformReply);
    };
}, _RedisClientMultiCommand_createModuleCommand = function _RedisClientMultiCommand_createModuleCommand(command, resp) {
    const transformReply = (0, commander_1.getTransformReply)(command, resp);
    return function () {
        return this.self.addCommand(command.transformArguments.apply(undefined, arguments), transformReply);
    };
}, _RedisClientMultiCommand_createFunctionCommand = function _RedisClientMultiCommand_createFunctionCommand(name, fn, resp) {
    const prefix = (0, commander_1.functionArgumentsPrefix)(name, fn), transformReply = (0, commander_1.getTransformReply)(fn, resp);
    return function () {
        const fnArgs = fn.transformArguments.apply(undefined, arguments), args = prefix.concat(fnArgs);
        args.preserve = fnArgs.preserve;
        return this.self.addCommand(args, transformReply);
    };
}, _RedisClientMultiCommand_createScriptCommand = function _RedisClientMultiCommand_createScriptCommand(script, resp) {
    const transformReply = (0, commander_1.getTransformReply)(script, resp);
    return function () {
        return this.addScript(script, script.transformArguments.apply(undefined, arguments), transformReply);
    };
};
