/// <reference types="node" />
import { RedisArgument, TuplesToMapReply, BlobStringReply, ArrayReply, Resp2Reply } from '../RESP/types';
type AclUser = TuplesToMapReply<[
    [
        BlobStringReply<'flags'>,
        ArrayReply<BlobStringReply>
    ],
    [
        BlobStringReply<'passwords'>,
        ArrayReply<BlobStringReply>
    ],
    [
        BlobStringReply<'commands'>,
        BlobStringReply
    ],
    /** changed to BlobStringReply in 7.0 */
    [
        BlobStringReply<'keys'>,
        ArrayReply<BlobStringReply> | BlobStringReply
    ],
    /** added in 6.2, changed to BlobStringReply in 7.0 */
    [
        BlobStringReply<'channels'>,
        ArrayReply<BlobStringReply> | BlobStringReply
    ],
    /** added in 7.0 */
    [
        BlobStringReply<'selectors'>,
        ArrayReply<TuplesToMapReply<[
            [
                BlobStringReply<'commands'>,
                BlobStringReply
            ],
            [
                BlobStringReply<'keys'>,
                BlobStringReply
            ],
            [
                BlobStringReply<'channels'>,
                BlobStringReply
            ]
        ]>>
    ]
]>;
declare const _default: {
    readonly FIRST_KEY_INDEX: undefined;
    readonly IS_READ_ONLY: true;
    readonly transformArguments: (this: void, username: RedisArgument) => RedisArgument[];
    readonly transformReply: {
        readonly 2: (reply: Resp2Reply<AclUser>) => {
            flags: ((string | Buffer) & {
                RESP_TYPE: 36;
                DEFAULT: string;
                TYPES: Buffer;
                /** added in 6.2, changed to BlobStringReply in 7.0 */
                FLAG: import("../RESP/types").Flag<string | Buffer>;
            })[] & {
                RESP_TYPE: 42;
                DEFAULT: ((string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    /** added in 6.2, changed to BlobStringReply in 7.0 */
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                })[];
                TYPES: never;
                /** added in 6.2, changed to BlobStringReply in 7.0 */
                FLAG: import("../RESP/types").Flag<((string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                })[]>;
            };
            passwords: ((string | Buffer) & {
                RESP_TYPE: 36;
                DEFAULT: string;
                TYPES: Buffer;
                /** added in 6.2, changed to BlobStringReply in 7.0 */
                FLAG: import("../RESP/types").Flag<string | Buffer>;
            })[] & {
                RESP_TYPE: 42;
                DEFAULT: ((string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    /** added in 6.2, changed to BlobStringReply in 7.0 */
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                })[];
                TYPES: never;
                /** added in 6.2, changed to BlobStringReply in 7.0 */
                FLAG: import("../RESP/types").Flag<((string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                })[]>;
            };
            commands: (string | Buffer) & {
                RESP_TYPE: 36;
                DEFAULT: string;
                TYPES: Buffer;
                /** added in 6.2, changed to BlobStringReply in 7.0 */
                FLAG: import("../RESP/types").Flag<string | Buffer>;
            };
            keys: (((string | Buffer) & {
                RESP_TYPE: 36;
                DEFAULT: string;
                TYPES: Buffer;
                /** added in 6.2, changed to BlobStringReply in 7.0 */
                FLAG: import("../RESP/types").Flag<string | Buffer>;
            })[] & {
                RESP_TYPE: 42;
                DEFAULT: ((string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    /** added in 6.2, changed to BlobStringReply in 7.0 */
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                })[];
                TYPES: never;
                /** added in 6.2, changed to BlobStringReply in 7.0 */
                FLAG: import("../RESP/types").Flag<((string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                })[]>;
            }) | ((string | Buffer) & {
                RESP_TYPE: 36;
                DEFAULT: string;
                TYPES: Buffer;
                /** added in 6.2, changed to BlobStringReply in 7.0 */
                FLAG: import("../RESP/types").Flag<string | Buffer>;
            });
            channels: (((string | Buffer) & {
                RESP_TYPE: 36;
                DEFAULT: string;
                TYPES: Buffer;
                /** added in 6.2, changed to BlobStringReply in 7.0 */
                FLAG: import("../RESP/types").Flag<string | Buffer>;
            })[] & {
                RESP_TYPE: 42;
                DEFAULT: ((string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    /** added in 6.2, changed to BlobStringReply in 7.0 */
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                })[];
                TYPES: never;
                /** added in 6.2, changed to BlobStringReply in 7.0 */
                FLAG: import("../RESP/types").Flag<((string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                })[]>;
            }) | ((string | Buffer) & {
                RESP_TYPE: 36;
                DEFAULT: string;
                TYPES: Buffer;
                /** added in 6.2, changed to BlobStringReply in 7.0 */
                FLAG: import("../RESP/types").Flag<string | Buffer>;
            });
            selectors: {
                commands: (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    /** added in 6.2, changed to BlobStringReply in 7.0 */
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                };
                keys: (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    /** added in 6.2, changed to BlobStringReply in 7.0 */
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                };
                channels: (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    /** added in 6.2, changed to BlobStringReply in 7.0 */
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                };
            }[];
        };
        readonly 3: () => AclUser;
    };
};
export default _default;
