/// <reference types="node" />
import { Resp2Reply } from '../RESP/types';
import { ArrayReply, BlobStringReply, NumberReply, TuplesToMapReply } from '../RESP/types';
export type AclLogReply = ArrayReply<TuplesToMapReply<[
    [
        BlobStringReply<'count'>,
        NumberReply
    ],
    [
        BlobStringReply<'reason'>,
        BlobStringReply
    ],
    [
        BlobStringReply<'context'>,
        BlobStringReply
    ],
    [
        BlobStringReply<'object'>,
        BlobStringReply
    ],
    [
        BlobStringReply<'username'>,
        BlobStringReply
    ],
    [
        BlobStringReply<'age-seconds'>,
        BlobStringReply
    ],
    [
        BlobStringReply<'client-info'>,
        BlobStringReply
    ]
]>>;
declare const _default: {
    readonly FIRST_KEY_INDEX: undefined;
    readonly IS_READ_ONLY: true;
    readonly transformArguments: (this: void, count?: number) => string[];
    readonly transformReply: {
        readonly 2: (reply: Resp2Reply<AclLogReply>) => {
            count: number;
            reason: [(Buffer | "count") & {
                RESP_TYPE: 36;
                DEFAULT: "count";
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<Buffer | "count">;
            }, (number | `${number}`) & {
                RESP_TYPE: 58;
                DEFAULT: number;
                TYPES: `${number}`;
                FLAG: import("../RESP/types").Flag<number | `${number}`>;
            }, (Buffer | "reason") & {
                RESP_TYPE: 36;
                DEFAULT: "reason";
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<Buffer | "reason">;
            }, (string | Buffer) & {
                RESP_TYPE: 36;
                DEFAULT: string;
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<string | Buffer>;
            }, (Buffer | "context") & {
                RESP_TYPE: 36;
                DEFAULT: "context";
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<Buffer | "context">;
            }, (string | Buffer) & {
                RESP_TYPE: 36;
                DEFAULT: string;
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<string | Buffer>;
            }, ("object" | Buffer) & {
                RESP_TYPE: 36;
                DEFAULT: "object";
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<"object" | Buffer>;
            }, (string | Buffer) & {
                RESP_TYPE: 36;
                DEFAULT: string;
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<string | Buffer>;
            }, (Buffer | "username") & {
                RESP_TYPE: 36;
                DEFAULT: "username";
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<Buffer | "username">;
            }, (string | Buffer) & {
                RESP_TYPE: 36;
                DEFAULT: string;
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<string | Buffer>;
            }, (Buffer | "age-seconds") & {
                RESP_TYPE: 36;
                DEFAULT: "age-seconds";
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<Buffer | "age-seconds">;
            }, (string | Buffer) & {
                RESP_TYPE: 36;
                DEFAULT: string;
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<string | Buffer>;
            }, (Buffer | "client-info") & {
                RESP_TYPE: 36;
                DEFAULT: "client-info";
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<Buffer | "client-info">;
            }, (string | Buffer) & {
                RESP_TYPE: 36;
                DEFAULT: string;
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<string | Buffer>;
            }] & {
                RESP_TYPE: 42;
                DEFAULT: [(Buffer | "count") & {
                    RESP_TYPE: 36;
                    DEFAULT: "count";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "count">;
                }, (number | `${number}`) & {
                    RESP_TYPE: 58;
                    DEFAULT: number;
                    TYPES: `${number}`;
                    FLAG: import("../RESP/types").Flag<number | `${number}`>;
                }, (Buffer | "reason") & {
                    RESP_TYPE: 36;
                    DEFAULT: "reason";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "reason">;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }, (Buffer | "context") & {
                    RESP_TYPE: 36;
                    DEFAULT: "context";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "context">;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }, ("object" | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: "object";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<"object" | Buffer>;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }, (Buffer | "username") & {
                    RESP_TYPE: 36;
                    DEFAULT: "username";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "username">;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }, (Buffer | "age-seconds") & {
                    RESP_TYPE: 36;
                    DEFAULT: "age-seconds";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "age-seconds">;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }, (Buffer | "client-info") & {
                    RESP_TYPE: 36;
                    DEFAULT: "client-info";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "client-info">;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }];
                TYPES: never;
                FLAG: import("../RESP/types").Flag<[(Buffer | "count") & {
                    RESP_TYPE: 36;
                    DEFAULT: "count";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "count">;
                }, (number | `${number}`) & {
                    RESP_TYPE: 58;
                    DEFAULT: number;
                    TYPES: `${number}`;
                    FLAG: import("../RESP/types").Flag<number | `${number}`>;
                }, (Buffer | "reason") & {
                    RESP_TYPE: 36;
                    DEFAULT: "reason";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "reason">;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }, (Buffer | "context") & {
                    RESP_TYPE: 36;
                    DEFAULT: "context";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "context">;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }, ("object" | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: "object";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<"object" | Buffer>;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }, (Buffer | "username") & {
                    RESP_TYPE: 36;
                    DEFAULT: "username";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "username">;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }, (Buffer | "age-seconds") & {
                    RESP_TYPE: 36;
                    DEFAULT: "age-seconds";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "age-seconds">;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }, (Buffer | "client-info") & {
                    RESP_TYPE: 36;
                    DEFAULT: "client-info";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "client-info">;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }]>;
            };
            context: [(Buffer | "count") & {
                RESP_TYPE: 36;
                DEFAULT: "count";
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<Buffer | "count">;
            }, (number | `${number}`) & {
                RESP_TYPE: 58;
                DEFAULT: number;
                TYPES: `${number}`;
                FLAG: import("../RESP/types").Flag<number | `${number}`>;
            }, (Buffer | "reason") & {
                RESP_TYPE: 36;
                DEFAULT: "reason";
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<Buffer | "reason">;
            }, (string | Buffer) & {
                RESP_TYPE: 36;
                DEFAULT: string;
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<string | Buffer>;
            }, (Buffer | "context") & {
                RESP_TYPE: 36;
                DEFAULT: "context";
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<Buffer | "context">;
            }, (string | Buffer) & {
                RESP_TYPE: 36;
                DEFAULT: string;
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<string | Buffer>;
            }, ("object" | Buffer) & {
                RESP_TYPE: 36;
                DEFAULT: "object";
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<"object" | Buffer>;
            }, (string | Buffer) & {
                RESP_TYPE: 36;
                DEFAULT: string;
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<string | Buffer>;
            }, (Buffer | "username") & {
                RESP_TYPE: 36;
                DEFAULT: "username";
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<Buffer | "username">;
            }, (string | Buffer) & {
                RESP_TYPE: 36;
                DEFAULT: string;
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<string | Buffer>;
            }, (Buffer | "age-seconds") & {
                RESP_TYPE: 36;
                DEFAULT: "age-seconds";
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<Buffer | "age-seconds">;
            }, (string | Buffer) & {
                RESP_TYPE: 36;
                DEFAULT: string;
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<string | Buffer>;
            }, (Buffer | "client-info") & {
                RESP_TYPE: 36;
                DEFAULT: "client-info";
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<Buffer | "client-info">;
            }, (string | Buffer) & {
                RESP_TYPE: 36;
                DEFAULT: string;
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<string | Buffer>;
            }] & {
                RESP_TYPE: 42;
                DEFAULT: [(Buffer | "count") & {
                    RESP_TYPE: 36;
                    DEFAULT: "count";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "count">;
                }, (number | `${number}`) & {
                    RESP_TYPE: 58;
                    DEFAULT: number;
                    TYPES: `${number}`;
                    FLAG: import("../RESP/types").Flag<number | `${number}`>;
                }, (Buffer | "reason") & {
                    RESP_TYPE: 36;
                    DEFAULT: "reason";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "reason">;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }, (Buffer | "context") & {
                    RESP_TYPE: 36;
                    DEFAULT: "context";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "context">;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }, ("object" | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: "object";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<"object" | Buffer>;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }, (Buffer | "username") & {
                    RESP_TYPE: 36;
                    DEFAULT: "username";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "username">;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }, (Buffer | "age-seconds") & {
                    RESP_TYPE: 36;
                    DEFAULT: "age-seconds";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "age-seconds">;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }, (Buffer | "client-info") & {
                    RESP_TYPE: 36;
                    DEFAULT: "client-info";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "client-info">;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }];
                TYPES: never;
                FLAG: import("../RESP/types").Flag<[(Buffer | "count") & {
                    RESP_TYPE: 36;
                    DEFAULT: "count";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "count">;
                }, (number | `${number}`) & {
                    RESP_TYPE: 58;
                    DEFAULT: number;
                    TYPES: `${number}`;
                    FLAG: import("../RESP/types").Flag<number | `${number}`>;
                }, (Buffer | "reason") & {
                    RESP_TYPE: 36;
                    DEFAULT: "reason";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "reason">;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }, (Buffer | "context") & {
                    RESP_TYPE: 36;
                    DEFAULT: "context";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "context">;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }, ("object" | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: "object";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<"object" | Buffer>;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }, (Buffer | "username") & {
                    RESP_TYPE: 36;
                    DEFAULT: "username";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "username">;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }, (Buffer | "age-seconds") & {
                    RESP_TYPE: 36;
                    DEFAULT: "age-seconds";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "age-seconds">;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }, (Buffer | "client-info") & {
                    RESP_TYPE: 36;
                    DEFAULT: "client-info";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "client-info">;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }]>;
            };
            object: [(Buffer | "count") & {
                RESP_TYPE: 36;
                DEFAULT: "count";
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<Buffer | "count">;
            }, (number | `${number}`) & {
                RESP_TYPE: 58;
                DEFAULT: number;
                TYPES: `${number}`;
                FLAG: import("../RESP/types").Flag<number | `${number}`>;
            }, (Buffer | "reason") & {
                RESP_TYPE: 36;
                DEFAULT: "reason";
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<Buffer | "reason">;
            }, (string | Buffer) & {
                RESP_TYPE: 36;
                DEFAULT: string;
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<string | Buffer>;
            }, (Buffer | "context") & {
                RESP_TYPE: 36;
                DEFAULT: "context";
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<Buffer | "context">;
            }, (string | Buffer) & {
                RESP_TYPE: 36;
                DEFAULT: string;
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<string | Buffer>;
            }, ("object" | Buffer) & {
                RESP_TYPE: 36;
                DEFAULT: "object";
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<"object" | Buffer>;
            }, (string | Buffer) & {
                RESP_TYPE: 36;
                DEFAULT: string;
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<string | Buffer>;
            }, (Buffer | "username") & {
                RESP_TYPE: 36;
                DEFAULT: "username";
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<Buffer | "username">;
            }, (string | Buffer) & {
                RESP_TYPE: 36;
                DEFAULT: string;
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<string | Buffer>;
            }, (Buffer | "age-seconds") & {
                RESP_TYPE: 36;
                DEFAULT: "age-seconds";
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<Buffer | "age-seconds">;
            }, (string | Buffer) & {
                RESP_TYPE: 36;
                DEFAULT: string;
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<string | Buffer>;
            }, (Buffer | "client-info") & {
                RESP_TYPE: 36;
                DEFAULT: "client-info";
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<Buffer | "client-info">;
            }, (string | Buffer) & {
                RESP_TYPE: 36;
                DEFAULT: string;
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<string | Buffer>;
            }] & {
                RESP_TYPE: 42;
                DEFAULT: [(Buffer | "count") & {
                    RESP_TYPE: 36;
                    DEFAULT: "count";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "count">;
                }, (number | `${number}`) & {
                    RESP_TYPE: 58;
                    DEFAULT: number;
                    TYPES: `${number}`;
                    FLAG: import("../RESP/types").Flag<number | `${number}`>;
                }, (Buffer | "reason") & {
                    RESP_TYPE: 36;
                    DEFAULT: "reason";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "reason">;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }, (Buffer | "context") & {
                    RESP_TYPE: 36;
                    DEFAULT: "context";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "context">;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }, ("object" | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: "object";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<"object" | Buffer>;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }, (Buffer | "username") & {
                    RESP_TYPE: 36;
                    DEFAULT: "username";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "username">;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }, (Buffer | "age-seconds") & {
                    RESP_TYPE: 36;
                    DEFAULT: "age-seconds";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "age-seconds">;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }, (Buffer | "client-info") & {
                    RESP_TYPE: 36;
                    DEFAULT: "client-info";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "client-info">;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }];
                TYPES: never;
                FLAG: import("../RESP/types").Flag<[(Buffer | "count") & {
                    RESP_TYPE: 36;
                    DEFAULT: "count";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "count">;
                }, (number | `${number}`) & {
                    RESP_TYPE: 58;
                    DEFAULT: number;
                    TYPES: `${number}`;
                    FLAG: import("../RESP/types").Flag<number | `${number}`>;
                }, (Buffer | "reason") & {
                    RESP_TYPE: 36;
                    DEFAULT: "reason";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "reason">;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }, (Buffer | "context") & {
                    RESP_TYPE: 36;
                    DEFAULT: "context";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "context">;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }, ("object" | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: "object";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<"object" | Buffer>;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }, (Buffer | "username") & {
                    RESP_TYPE: 36;
                    DEFAULT: "username";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "username">;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }, (Buffer | "age-seconds") & {
                    RESP_TYPE: 36;
                    DEFAULT: "age-seconds";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "age-seconds">;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }, (Buffer | "client-info") & {
                    RESP_TYPE: 36;
                    DEFAULT: "client-info";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "client-info">;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }]>;
            };
            username: [(Buffer | "count") & {
                RESP_TYPE: 36;
                DEFAULT: "count";
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<Buffer | "count">;
            }, (number | `${number}`) & {
                RESP_TYPE: 58;
                DEFAULT: number;
                TYPES: `${number}`;
                FLAG: import("../RESP/types").Flag<number | `${number}`>;
            }, (Buffer | "reason") & {
                RESP_TYPE: 36;
                DEFAULT: "reason";
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<Buffer | "reason">;
            }, (string | Buffer) & {
                RESP_TYPE: 36;
                DEFAULT: string;
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<string | Buffer>;
            }, (Buffer | "context") & {
                RESP_TYPE: 36;
                DEFAULT: "context";
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<Buffer | "context">;
            }, (string | Buffer) & {
                RESP_TYPE: 36;
                DEFAULT: string;
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<string | Buffer>;
            }, ("object" | Buffer) & {
                RESP_TYPE: 36;
                DEFAULT: "object";
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<"object" | Buffer>;
            }, (string | Buffer) & {
                RESP_TYPE: 36;
                DEFAULT: string;
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<string | Buffer>;
            }, (Buffer | "username") & {
                RESP_TYPE: 36;
                DEFAULT: "username";
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<Buffer | "username">;
            }, (string | Buffer) & {
                RESP_TYPE: 36;
                DEFAULT: string;
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<string | Buffer>;
            }, (Buffer | "age-seconds") & {
                RESP_TYPE: 36;
                DEFAULT: "age-seconds";
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<Buffer | "age-seconds">;
            }, (string | Buffer) & {
                RESP_TYPE: 36;
                DEFAULT: string;
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<string | Buffer>;
            }, (Buffer | "client-info") & {
                RESP_TYPE: 36;
                DEFAULT: "client-info";
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<Buffer | "client-info">;
            }, (string | Buffer) & {
                RESP_TYPE: 36;
                DEFAULT: string;
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<string | Buffer>;
            }] & {
                RESP_TYPE: 42;
                DEFAULT: [(Buffer | "count") & {
                    RESP_TYPE: 36;
                    DEFAULT: "count";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "count">;
                }, (number | `${number}`) & {
                    RESP_TYPE: 58;
                    DEFAULT: number;
                    TYPES: `${number}`;
                    FLAG: import("../RESP/types").Flag<number | `${number}`>;
                }, (Buffer | "reason") & {
                    RESP_TYPE: 36;
                    DEFAULT: "reason";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "reason">;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }, (Buffer | "context") & {
                    RESP_TYPE: 36;
                    DEFAULT: "context";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "context">;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }, ("object" | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: "object";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<"object" | Buffer>;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }, (Buffer | "username") & {
                    RESP_TYPE: 36;
                    DEFAULT: "username";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "username">;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }, (Buffer | "age-seconds") & {
                    RESP_TYPE: 36;
                    DEFAULT: "age-seconds";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "age-seconds">;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }, (Buffer | "client-info") & {
                    RESP_TYPE: 36;
                    DEFAULT: "client-info";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "client-info">;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }];
                TYPES: never;
                FLAG: import("../RESP/types").Flag<[(Buffer | "count") & {
                    RESP_TYPE: 36;
                    DEFAULT: "count";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "count">;
                }, (number | `${number}`) & {
                    RESP_TYPE: 58;
                    DEFAULT: number;
                    TYPES: `${number}`;
                    FLAG: import("../RESP/types").Flag<number | `${number}`>;
                }, (Buffer | "reason") & {
                    RESP_TYPE: 36;
                    DEFAULT: "reason";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "reason">;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }, (Buffer | "context") & {
                    RESP_TYPE: 36;
                    DEFAULT: "context";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "context">;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }, ("object" | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: "object";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<"object" | Buffer>;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }, (Buffer | "username") & {
                    RESP_TYPE: 36;
                    DEFAULT: "username";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "username">;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }, (Buffer | "age-seconds") & {
                    RESP_TYPE: 36;
                    DEFAULT: "age-seconds";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "age-seconds">;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }, (Buffer | "client-info") & {
                    RESP_TYPE: 36;
                    DEFAULT: "client-info";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "client-info">;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }]>;
            };
            'age-seconds': number;
            'client-info': [(Buffer | "count") & {
                RESP_TYPE: 36;
                DEFAULT: "count";
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<Buffer | "count">;
            }, (number | `${number}`) & {
                RESP_TYPE: 58;
                DEFAULT: number;
                TYPES: `${number}`;
                FLAG: import("../RESP/types").Flag<number | `${number}`>;
            }, (Buffer | "reason") & {
                RESP_TYPE: 36;
                DEFAULT: "reason";
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<Buffer | "reason">;
            }, (string | Buffer) & {
                RESP_TYPE: 36;
                DEFAULT: string;
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<string | Buffer>;
            }, (Buffer | "context") & {
                RESP_TYPE: 36;
                DEFAULT: "context";
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<Buffer | "context">;
            }, (string | Buffer) & {
                RESP_TYPE: 36;
                DEFAULT: string;
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<string | Buffer>;
            }, ("object" | Buffer) & {
                RESP_TYPE: 36;
                DEFAULT: "object";
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<"object" | Buffer>;
            }, (string | Buffer) & {
                RESP_TYPE: 36;
                DEFAULT: string;
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<string | Buffer>;
            }, (Buffer | "username") & {
                RESP_TYPE: 36;
                DEFAULT: "username";
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<Buffer | "username">;
            }, (string | Buffer) & {
                RESP_TYPE: 36;
                DEFAULT: string;
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<string | Buffer>;
            }, (Buffer | "age-seconds") & {
                RESP_TYPE: 36;
                DEFAULT: "age-seconds";
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<Buffer | "age-seconds">;
            }, (string | Buffer) & {
                RESP_TYPE: 36;
                DEFAULT: string;
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<string | Buffer>;
            }, (Buffer | "client-info") & {
                RESP_TYPE: 36;
                DEFAULT: "client-info";
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<Buffer | "client-info">;
            }, (string | Buffer) & {
                RESP_TYPE: 36;
                DEFAULT: string;
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<string | Buffer>;
            }] & {
                RESP_TYPE: 42;
                DEFAULT: [(Buffer | "count") & {
                    RESP_TYPE: 36;
                    DEFAULT: "count";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "count">;
                }, (number | `${number}`) & {
                    RESP_TYPE: 58;
                    DEFAULT: number;
                    TYPES: `${number}`;
                    FLAG: import("../RESP/types").Flag<number | `${number}`>;
                }, (Buffer | "reason") & {
                    RESP_TYPE: 36;
                    DEFAULT: "reason";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "reason">;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }, (Buffer | "context") & {
                    RESP_TYPE: 36;
                    DEFAULT: "context";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "context">;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }, ("object" | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: "object";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<"object" | Buffer>;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }, (Buffer | "username") & {
                    RESP_TYPE: 36;
                    DEFAULT: "username";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "username">;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }, (Buffer | "age-seconds") & {
                    RESP_TYPE: 36;
                    DEFAULT: "age-seconds";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "age-seconds">;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }, (Buffer | "client-info") & {
                    RESP_TYPE: 36;
                    DEFAULT: "client-info";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "client-info">;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }];
                TYPES: never;
                FLAG: import("../RESP/types").Flag<[(Buffer | "count") & {
                    RESP_TYPE: 36;
                    DEFAULT: "count";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "count">;
                }, (number | `${number}`) & {
                    RESP_TYPE: 58;
                    DEFAULT: number;
                    TYPES: `${number}`;
                    FLAG: import("../RESP/types").Flag<number | `${number}`>;
                }, (Buffer | "reason") & {
                    RESP_TYPE: 36;
                    DEFAULT: "reason";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "reason">;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }, (Buffer | "context") & {
                    RESP_TYPE: 36;
                    DEFAULT: "context";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "context">;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }, ("object" | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: "object";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<"object" | Buffer>;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }, (Buffer | "username") & {
                    RESP_TYPE: 36;
                    DEFAULT: "username";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "username">;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }, (Buffer | "age-seconds") & {
                    RESP_TYPE: 36;
                    DEFAULT: "age-seconds";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "age-seconds">;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }, (Buffer | "client-info") & {
                    RESP_TYPE: 36;
                    DEFAULT: "client-info";
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<Buffer | "client-info">;
                }, (string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                }]>;
            };
        };
        readonly 3: () => AclLogReply;
    };
};
export default _default;
