import { NumberReply, ArrayReply, BlobStringReply } from '../RESP/types';
type RawNode = [
    host: BlobStringReply,
    port: NumberReply,
    id: BlobStringReply
];
type ClusterSlotsRawReply = ArrayReply<[
    from: NumberReply,
    to: NumberReply,
    master: RawNode,
    ...replicas: Array<RawNode>
]>;
export type ClusterSlotsNode = ReturnType<typeof transformNode>;
declare const _default: {
    readonly IS_READ_ONLY: true;
    readonly transformArguments: (this: void) => string[];
    readonly transformReply: (this: void, reply: ClusterSlotsRawReply) => {
        from: NumberReply;
        to: NumberReply;
        master: {
            host: BlobStringReply;
            port: NumberReply;
            id: BlobStringReply;
        };
        replicas: {
            host: BlobStringReply;
            port: NumberReply;
            id: BlobStringReply;
        }[];
    }[];
};
export default _default;
declare function transformNode([host, port, id]: RawNode): {
    host: BlobStringReply;
    port: NumberReply;
    id: BlobStringReply;
};
