/// <reference types="node" />
import { RedisArgument, ArrayReply, BlobStringReply, NumberReply, Resp2Reply, RespVersions, TuplesToMapReply } from '../RESP/types';
export interface HelloOptions {
    AUTH?: {
        username: RedisArgument;
        password: RedisArgument;
    };
    SETNAME?: string;
}
export type HelloReply = TuplesToMapReply<[
    [
        BlobStringReply<'server'>,
        BlobStringReply
    ],
    [
        BlobStringReply<'version'>,
        BlobStringReply
    ],
    [
        BlobStringReply<'proto'>,
        NumberReply<RespVersions>
    ],
    [
        BlobStringReply<'id'>,
        NumberReply
    ],
    [
        BlobStringReply<'mode'>,
        BlobStringReply
    ],
    [
        BlobStringReply<'role'>,
        BlobStringReply
    ],
    [
        BlobStringReply<'modules'>,
        ArrayReply<BlobStringReply>
    ]
]>;
declare const _default: {
    readonly transformArguments: (this: void, protoover: RespVersions, options?: HelloOptions) => RedisArgument[];
    readonly transformReply: {
        readonly 2: (reply: Resp2Reply<HelloReply>) => {
            server: (string | Buffer) & {
                RESP_TYPE: 36;
                DEFAULT: string;
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<string | Buffer>;
            };
            version: (string | Buffer) & {
                RESP_TYPE: 36;
                DEFAULT: string;
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<string | Buffer>;
            };
            proto: (RespVersions | "2" | "3") & {
                RESP_TYPE: 58;
                DEFAULT: RespVersions;
                TYPES: "2" | "3";
                FLAG: import("../RESP/types").Flag<RespVersions | "2" | "3">;
            };
            id: (number | `${number}`) & {
                RESP_TYPE: 58;
                DEFAULT: number;
                TYPES: `${number}`;
                FLAG: import("../RESP/types").Flag<number | `${number}`>;
            };
            mode: (string | Buffer) & {
                RESP_TYPE: 36;
                DEFAULT: string;
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<string | Buffer>;
            };
            role: (string | Buffer) & {
                RESP_TYPE: 36;
                DEFAULT: string;
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<string | Buffer>;
            };
            modules: ((string | Buffer) & {
                RESP_TYPE: 36;
                DEFAULT: string;
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<string | Buffer>;
            })[] & {
                RESP_TYPE: 42;
                DEFAULT: ((string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                })[];
                TYPES: never;
                FLAG: import("../RESP/types").Flag<((string | Buffer) & {
                    RESP_TYPE: 36;
                    DEFAULT: string;
                    TYPES: Buffer;
                    FLAG: import("../RESP/types").Flag<string | Buffer>;
                })[]>;
            };
        };
        readonly 3: () => HelloReply;
    };
};
export default _default;
