/// <reference types="node" />
import { ArrayReply, BlobStringReply, NumberReply, Resp2Reply, TuplesToMapReply } from '../RESP/types';
export type ModuleListReply = ArrayReply<TuplesToMapReply<[
    [
        BlobStringReply<'name'>,
        BlobStringReply
    ],
    [
        BlobStringReply<'version'>,
        NumberReply
    ]
]>>;
declare const _default: {
    readonly FIRST_KEY_INDEX: undefined;
    readonly IS_READ_ONLY: true;
    readonly transformArguments: (this: void) => string[];
    readonly transformReply: {
        readonly 2: (reply: Resp2Reply<ModuleListReply>) => {
            name: (string | Buffer) & {
                RESP_TYPE: 36;
                DEFAULT: string;
                TYPES: Buffer;
                FLAG: import("../RESP/types").Flag<string | Buffer>;
            };
            version: (number | `${number}`) & {
                RESP_TYPE: 58;
                DEFAULT: number;
                TYPES: `${number}`;
                FLAG: import("../RESP/types").Flag<number | `${number}`>;
            };
        }[];
        readonly 3: () => ModuleListReply;
    };
};
export default _default;
