import { ArrayReply, BlobStringReply, NumberReply } from '../RESP/types';
type MasterRole = [
    role: BlobStringReply<'master'>,
    replicationOffest: NumberReply,
    replicas: ArrayReply<[host: BlobStringReply, port: NumberReply, replicationOffest: NumberReply]>
];
type SlaveRole = [
    role: BlobStringReply<'slave'>,
    masterHost: BlobStringReply,
    masterPort: NumberReply,
    state: BlobStringReply<'connect' | 'connecting' | 'sync' | 'connected'>,
    dataReceived: NumberReply
];
type SentinelRole = [
    role: BlobStringReply<'sentinel'>,
    masterNames: ArrayReply<BlobStringReply>
];
type Role = MasterRole | SlaveRole | SentinelRole;
declare const _default: {
    readonly FIRST_KEY_INDEX: undefined;
    readonly IS_READ_ONLY: true;
    readonly transformArguments: (this: void) => string[];
    readonly transformReply: (this: void, reply: Role) => {
        role: BlobStringReply<"master">;
        replicationOffest: NumberReply;
        replicas: {
            host: BlobStringReply;
            port: NumberReply;
            replicationOffest: NumberReply;
        }[];
        master?: undefined;
        state?: undefined;
        dataReceived?: undefined;
        masterNames?: undefined;
    } | {
        role: BlobStringReply<"slave">;
        master: {
            host: BlobStringReply;
            port: NumberReply;
        };
        state: BlobStringReply<"connect" | "connected" | "connecting" | "sync">;
        dataReceived: NumberReply;
        replicationOffest?: undefined;
        replicas?: undefined;
        masterNames?: undefined;
    } | {
        role: BlobStringReply<"sentinel">;
        masterNames: ArrayReply<BlobStringReply>;
        replicationOffest?: undefined;
        replicas?: undefined;
        master?: undefined;
        state?: undefined;
        dataReceived?: undefined;
    };
};
export default _default;
