import { RedisArgument, NumberReply, DoubleReply } from '../RESP/types';
import { ZMember, transformDoubleReply } from './generic-transformers';
export interface ZAddOptions {
    condition?: 'NX' | 'XX';
    /**
     * @deprecated Use `{ condition: 'NX' }` instead.
     */
    NX?: boolean;
    /**
     * @deprecated Use `{ condition: 'XX' }` instead.
     */
    XX?: boolean;
    comparison?: 'LT' | 'GT';
    /**
     * @deprecated Use `{ comparison: 'LT' }` instead.
     */
    LT?: boolean;
    /**
     * @deprecated Use `{ comparison: 'GT' }` instead.
     */
    GT?: boolean;
    CH?: boolean;
    INCR?: boolean;
}
declare const _default: {
    readonly FIRST_KEY_INDEX: 1;
    readonly transformArguments: (this: void, key: RedisArgument, members: ZMember | Array<ZMember>, options?: ZAddOptions) => RedisArgument[];
    readonly transformReply: {
        readonly 2: typeof transformDoubleReply;
        readonly 3: () => NumberReply | DoubleReply;
    };
};
export default _default;
