"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.pushZInterArguments = void 0;
const generic_transformers_1 = require("./generic-transformers");
function pushZInterArguments(args, keys, options) {
    if (Array.isArray(keys)) {
        args.push(keys.length.toString());
        if (keys.length) {
            if (isPlainKeys(keys)) {
                args = args.concat(keys);
            }
            else {
                const start = args.length;
                args[start + keys.length] = 'WEIGHTS';
                for (let i = 0; i < keys.length; i++) {
                    const index = start + i;
                    args[index] = keys[i].key;
                    args[index + 1 + keys.length] = (0, generic_transformers_1.transformDoubleArgument)(keys[i].weight);
                }
            }
        }
    }
    else {
        args.push('1');
        if (isPlainKey(keys)) {
            args.push(keys);
        }
        else {
            args.push(keys.key, 'WEIGHTS', (0, generic_transformers_1.transformDoubleArgument)(keys.weight));
        }
    }
    if (options?.AGGREGATE) {
        args.push('AGGREGATE', options.AGGREGATE);
    }
    return args;
}
exports.pushZInterArguments = pushZInterArguments;
function isPlainKey(key) {
    return typeof key === 'string' || Buffer.isBuffer(key);
}
function isPlainKeys(keys) {
    return isPlainKey(keys[0]);
}
exports.default = {
    FIRST_KEY_INDEX: 2,
    IS_READ_ONLY: true,
    transformArguments(keys, options) {
        return pushZInterArguments(['ZINTER'], keys, options);
    },
    transformReply: undefined
};
