import { CommandArguments, RedisScript, TransformReply } from './RESP/types';
export interface RedisMultiQueuedCommand {
    args: CommandArguments;
    transformReply?: TransformReply;
}
export default class RedisMultiCommand {
    static generateChainId(): symbol;
    readonly queue: Array<RedisMultiQueuedCommand>;
    readonly scriptsInUse: Set<string>;
    addCommand(args: CommandArguments, transformReply?: TransformReply): this;
    addScript(script: RedisScript, args: CommandArguments, transformReply?: TransformReply): this;
    handleExecReplies(rawReplies: Array<unknown>): Array<unknown>;
    transformReplies(rawReplies: Array<unknown>): Array<unknown>;
}
